<template>
  <v-app id="inspire">
    <v-main>
      <v-container
        class="fill-height"
        fluid
      >
        <v-row
          align="center"
          justify="center"
        >
          <v-col
            cols="12"
            sm="8"
            md="6"
          >
            <v-card class="elevation-12">
              <v-toolbar
                color="primary"
                dark
                flat
              >
                <v-toolbar-title>Регистрация</v-toolbar-title>
                <v-spacer />
              </v-toolbar>
              <v-card-text>
                <v-form ref="form" v-model="valid" lazy-validation>
                  <v-text-field
                    v-model="fullName"
                    :rules="fullNameRules"
                    label="Фамилия Имя Отчество"
                    prepend-icon="mdi-account"
                    type="text"
                    required
                  />

                  <v-text-field
                    v-model="username"
                    :rules="usernameRules"
                    label="Логин"
                    prepend-icon="mdi-account"
                    type="text"
                    required
                  />

                  <v-text-field
                    v-model="password"
                    :rules="[v => !!v || 'Поле обязательно для заполнения']"
                    label="Пароль"
                    prepend-icon="mdi-lock"
                    type="password"
                    required
                  />

                  <v-text-field
                    v-model="confPassword"
                    :rules="[v => !!v || 'Поле обязательно для заполнения', passwordConfirmationRule]"
                    label="Повторите пароль"
                    prepend-icon="mdi-lock"
                    type="password"
                    required
                  />

                  <v-checkbox
                    v-model="checkbox"
                    :rules="[v => !!v || 'Вы должны согласиться, чтобы продолжить!']"
                    label="Вы согласны?"
                    required
                  />
                </v-form>
              </v-card-text>
              <v-alert
                v-if="error"
                dense
                outlined
                type="error"
              >
                {{ error }}
              </v-alert>
              <v-card-actions>
                <v-btn color="secondary" large to="login">
                  Авторизация
                </v-btn>
                <v-spacer />
                <v-btn color="success" large :disabled="!valid" @click="validate">
                  Зарегистрироваться
                </v-btn>
              </v-card-actions>
            </v-card>
          </v-col>
        </v-row>
      </v-container>
    </v-main>
  </v-app>
</template>

<script>
export default {
  data: () => ({
    valid: true,
    fullName: '',
    fullNameRules: [
      v => !!v || 'Поле обязательно для заполнения'
    ],
    username: '',
    usernameRules: [
      v => !!v || 'Поле обязательно для заполнения'
    ],
    password: '',
    confPassword: '',
    checkbox: false,
    error: ''
  }),

  computed: {
    passwordConfirmationRule () {
      return () => (this.password === this.confPassword) || 'Пароли не совпадают!'
    }
  },

  methods: {
    validate () {
      if (this.$refs.form.validate()) {
        this.register()
      }
    },
    async register () {
      try {
        await this.$axios
          .post('register', {
            username: this.username,
            fullName: this.fullName,
            password: this.password
          })

        this.$router.push('/login')
      } catch (e) {
        this.error = e.response.data.error
      }
    }
  },

  head () {
    return {
      title: 'Регистрация',
      meta: [
        {
          hid: 'Регистрация',
          name: 'Регистрация',
          content: 'Регистрация'
        }
      ]
    }
  }
}
</script>
